print();

BeetHarvestAddon = Mod:init()

-- BeetHarvestAddon:enableDebugMode()

function BeetHarvestAddon:initMission()
    if g_storeManager ~= nil then
        local success = g_storeManager:addCategory("SELLSTATIONS", g_i18n:getText("store_category_sellPoints"), "store_category_sellpoints.dds", "PLACEABLE", self.dir);
    end

    
end


function BeetHarvestAddon:loadMap()
    -- self:initSettings()
    -- self:registerFillTypes()
    self:registerMaterials()


    -- self:printDebugVar("getIsSeasonsActive", self:getIsSeasonsActive())
    -- self:printDebugVar("getIsMaizePlusActive", self:getIsMaizePlusActive())
    -- self:printDebugVar("getIsMaizePlusForageActive", self:getIsMaizePlusForageActive())
end

function BeetHarvestAddon:initSettings()
    local settings = self.settings:init("beetHarvestAddon", "defaultSettings.xml", "beetHarvestAddon.xml");

    -- Set initial/fallback values for settings
    settings.useMonochromeIcons = true
    settings.unclampPrices = false
    settings.autoAddToSellpoints = true
    settings.excludePulpFromBGA = false

    -- Load actual settings from both the default settings file from the mod and user settings from the modsSettings-folder
    settings:load(function(xmlReader)
        settings.useMonochromeIcons = xmlReader:readBool(nil, "useMonochromeIcons", settings.useMonochromeIcons)
        settings.unclampPrices = xmlReader:readBool(nil, "unclampPrices", settings.unclampPrices)
        settings.autoAddToSellpoints = xmlReader:readBool(nil, "autoAddToSellpoints", settings.autoAddToSellpoints)
        settings.excludePulpFromBGA = xmlReader:readBool(nil, "excludePulpFromBGA", settings.excludePulpFromBGA)
    end)

    -- This will auto-save all default settings to the user settings file (in modsSettings-folder) on the first run
    self.settings:save(function(xmlWriter)
        xmlWriter:saveBool(nil, "useMonochromeIcons", settings.useMonochromeIcons)
        xmlWriter:saveBool(nil, "unclampPrices", settings.unclampPrices)
        xmlWriter:saveBool(nil, "autoAddToSellpoints", settings.autoAddToSellpoints)
        xmlWriter:saveBool(nil, "excludePulpFromBGA", settings.excludePulpFromBGA)
    end);

end

function BeetHarvestAddon:missionLoaded()
    BeetHarvestAddon:printDebug("Mission loaded")
end



function BeetHarvestAddon:beforeLoadMap()
    BeetHarvestAddon:printDebug("Before Load Map")
    
end

function BeetHarvestAddon:startMission()
    BeetHarvestAddon:printDebug("Start mission")

--    BeetHarvestAddon:prepareFoodMixtures()


    -- DebugUtil.printTableRecursively(g_animalFoodManager.foodGroups, "g_animalFoodManager.foodGroups:: ")
    -- DebugUtil.printTableRecursively(g_animalFoodManager.foodMixtures, "g_animalFoodManager.foodMixtures:: ")
    -- DebugUtil.printTableRecursively(g_animalFoodManager.animalFoodMixtures, "g_animalFoodManager.animalFoodMixtures:: ")
    
    -- DebugUtil.printTableRecursively(g_animalFoodManager.foodGroups.PIG, "g_animalFoodManager.foodGroups.PIG:: ", 0, 5)
    -- DebugUtil.printTableRecursively(g_animalFoodManager.foodGroups.COW, "g_animalFoodManager.foodGroups.COW:: ", 0, 5)
    -- DebugUtil.printTableRecursively(g_animalFoodManager.foodGroups.SHEEP, "g_animalFoodManager.foodGroups.SHEEP:: ", 0, 5)

    -- DebugUtil.printTableRecursively(g_animalFoodManager, "foodManager4:: ", 0, 5)

    -- table.insert( g_animalFoodManager.foodGroups.COW.content[1].fillTypes, FillType.FEEDPELLETS )
    
    
end

function BeetHarvestAddon:beforeStartMission()
    BeetHarvestAddon:printDebug("Before Start mission")

    




    if self:getIsStrawHarvestActive() then -- Re-align prices with the buyable molasses from StrawHarvest and with production from SugarBeetHarvest
        BeetHarvestAddon:printInfo("StrawHarvest Addon is active, adjusting pricing to align mods")
        -- molassesFillType
    end
    
end

-- function BeetHarvestAddon:update()
    
-- end

function BeetHarvestAddon:loadMapFinished()
    BeetHarvestAddon:printDebug("Map finish")
    -- DebugUtil.printTableRecursively(self, "self:: ", 0, 2)
end

--- Do some late fixes, especially to align mod with StrawHarvest Addon
function BeetHarvestAddon:afterLoadMapFinished()
    
    local molassesFillType = g_fillTypeManager:getFillTypeByName("MOLASSES")

    if molassesFillType ~= nil then

        -- DebugUtil.printTableRecursively(molassesFillType, "molassesFillType:: ", 0, 3)

        molassesFillType.showOnPriceTable = true -- Make sure molasses is visible even with straw harvest addon

        -- self:printDebugVar("molassesFillType.pricePerLiter:before", molassesFillType.pricePerLiter)

        if molassesFillType.pricePerLiter ~= self.priceLevels.molasses then
            molassesFillType.pricePerLiter = self.priceLevels.molasses
            -- startPricePerLiter
        end


        -- Special fix to replace the default straw harvest icon with our colorful option when colorful icons is enabled
        if not self.settings.useMonochromeIcons and self:getIsStrawHarvestActive() then
            local hudFilename, hudFilenameSmall = self:getHudFileNames("molasses")
            molassesFillType.hudOverlayFilename = Utils.getFilename(hudFilename, self:getFullHudDir())
            molassesFillType.hudOverlayFilenameSmall = Utils.getFilename(hudFilenameSmall, self:getFullHudDir())
        end
        -- self:printDebugVar("molassesFillType.pricePerLiter:after", molassesFillType.pricePerLiter)
    end    
end

function BeetHarvestAddon:prepareGlobalCompanyIcons()

end

-- FillTypeManager.loadMapData = Utils.appendedFunction(FillTypeManager.loadMapData, registerPelletFillTypes)

FillTypeManager.loadMapData = Utils.appendedFunction(FillTypeManager.loadMapData, function()
    BeetHarvestAddon:initSettings()
    BeetHarvestAddon:registerFillTypes()
    -- BeetHarvestAddon:prepareFoodMixtures()
end)

function BeetHarvestAddon:prepareFoodMixtures(foodManager)
    foodManager = foodManager or g_animalFoodManager

    if foodManager.foodMixtures[FillType.FEEDPELLETS] == nil then

        local function getFeedPelletMixtureIngredients()
            
            if not BeetHarvestAddon:getIsMaizePlusForageActive() then
                return {
                    { weight = 0.8, fillTypes = { FillType.FEEDPELLETS } },
                    { weight = 0.2, fillTypes = { FillType.BEETPULP } },
                }
            else  -- Special case only for Maize+ with Forage extension
                return {
                    { weight = 0.4, fillTypes = { FillType.FEEDPELLETS } },
                    { weight = 0.4, fillTypes = { FillType.BEETPULP } },
                    { weight = 0.2, fillTypes = { FillType.MOLASSES } },
                }
            end
        end

        foodManager.foodMixtures = foodManager.foodMixtures or {}

        foodManager.foodMixtures[FillType.FEEDPELLETS] = {
            ingredients = getFeedPelletMixtureIngredients()
        }
    end
    

    -- g_animalFoodManager.animalFoodMixtures["PIG"] = { FillType.FEEDPELLETS }
    foodManager.animalFoodMixtures["COW"] = { FillType.FEEDPELLETS }
    foodManager.animalFoodMixtures["PIG"] = { FillType.FEEDPELLETS }
    -- g_animalFoodManager.foodGroups.PIG.content[1].fillTypes = { FillType.FEEDPELLETS }
    -- g_animalFoodManager.foodGroups.PIG.content[2].fillTypes = { FillType.FEEDPELLETS }

end

function BeetHarvestAddon:registerMaterials()
    local function loadMaterialHolder(fillTypeName)
        fillTypeName = tostring(fillTypeName)
        local filename = Utils.getFilename(string.format( "fillTypes/%s_materialHolder.i3d", fillTypeName ), self.dir)
        return loadI3DFile(filename, false, true, false)
    end

    loadMaterialHolder("sugar")
    loadMaterialHolder("beetPulp")
    loadMaterialHolder("feedPellets")
end


function BeetHarvestAddon:getHudFileNames(fillTypeName)
    local normalHudFile = string.format( "hud_fill_%s.dds", fillTypeName )
    local smallHudFile = string.format( "hud_fill_%s_sml.dds", fillTypeName )
    return normalHudFile, smallHudFile
end

function BeetHarvestAddon:getHudDir()
    local hudDirExtra = (self.settings.useMonochromeIcons == true and "monochrome/") or ""
    return "hud/" .. hudDirExtra
end

function BeetHarvestAddon:getFullHudDir()
    return Utils.getFilename(self:getHudDir(), self.dir)
end



function BeetHarvestAddon:registerFillTypes()

    ---@param fillTypeName string
    ---@param price float Price (€/$/£) per liter
    ---@param mass float Mass (kg) per liter
    ---@param heapAngle float Maximum heap angle (degrees)
    local function addFillTypeToCurrentMission(fillTypeName, price, mass, heapAngle)
            if fillTypeName == nil or type(fillTypeName) ~= "string" then
                return
            end

            -- local normalHudFile = string.format( "hud_fill_%s.dds", fillTypeName )
            -- local smallHudFile = string.format( "hud_fill_%s_sml.dds", fillTypeName )
            local normalHudFile, smallHudFile = self:getHudFileNames(fillTypeName)
            local fillPlaneColors = { 1, 1, 1 }
            -- local hudDirExtra = (self.settings.useMonochromeIcons == true and "monochrome/") or ""
            -- local hudDir = "hud/" .. hudDirExtra
            local hudDir = self:getFullHudDir()

            self:printDebugVar("normalHudFile", normalHudFile)
            self:printDebugVar("smallHudFile", smallHudFile)
            self:printDebugVar("hudDir", hudDir)

            local fillType = g_fillTypeManager:addFillType(fillTypeName:upper(), g_i18n:getText(fillTypeName), true, price, mass, math.rad(heapAngle), normalHudFile, smallHudFile, hudDir, nil, fillPlaneColors, nil, false)

            if fillType == nil then
                self:printWarning("Failed to add filltype '" .. tostring(fillTypeName).."' to current mission")
            end
    end

    local function addHeightTypeToMission(fillTypeName, heapAngle, allowSmoothing, soundFillTypeName, fillToGroundScale, collisionScale, baseOffset, minOffset, maxOffset)
        local fillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(fillTypeName)
    
        g_fillTypeManager.fillTypeToSample[fillTypeIndex] = g_fillTypeManager.fillTypeToSample[g_fillTypeManager:getFillTypeIndexByName(soundFillTypeName)]

        local function textureFilename(fillTypeName, typeName)
            fillTypeName = tostring(fillTypeName)
            return Utils.getFilename(string.format( "fillTypes/%s_%s.dds", fillTypeName:lower(), typeName ), self.dir)
        end
    
        local diffuseTextureFilename = Utils.getFilename("fillTypes/" .. fillTypeName .. "_diffuse.dds", self.dir)
        local normalTextureFilename = Utils.getFilename("fillTypes/" .. fillTypeName .. "_normal.dds", self.dir)
        local specularTextureFilename = Utils.getFilename("fillTypes/" .. fillTypeName .. "_specular.dds", self.dir)
        local distanceTextureFilename = Utils.getFilename("fillTypes/" .. fillTypeName .. "_distance_diffuse.dds", self.dir)

        -- Defaults
        fillToGroundScale = fillToGroundScale or 1.0
        collisionScale = collisionScale or 1.0
        baseOffset = baseOffset or 0.0
        minOffset = minOffset or 0.0
        maxOffset = maxOffset or 0.0
        soundFillTypeName = soundFillTypeName or fillTypeName
    
        local heightType = g_densityMapHeightManager:addDensityMapHeightType(fillTypeName, math.rad(heapAngle), collisionScale, baseOffset, minOffset, maxOffset, fillToGroundScale, allowSmoothing, diffuseTextureFilename, normalTextureFilename, distanceTextureFilename, false)
        if heightType == nil then
            self:printWarning("HeightType '" .. tostring(fillTypeName).."' could not be added to the current mission")
        end
    end

    local function addFillTypeToCategories(fillTypeName, categoryNames)
		local fillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(fillTypeName)

        if fillTypeIndex == nil then
            self:printWarning("Filltype '" .. tostring(fillTypeName).."' was not found")
            return
        end
		
        self:printDebugVar("FillType " .. fillTypeName, fillTypeIndex)
		for _, category in pairs(categoryNames) do
            self:printDebugVar("Category " .. category, g_fillTypeManager.nameToCategoryIndex[category])
			g_fillTypeManager:addFillTypeToCategory(fillTypeIndex, g_fillTypeManager.nameToCategoryIndex[category])
		end
    end

    -- local function addFillTypeToCurrentMission(fillTypeName, price)

    --     -- 	<fillType name="OILSEEDRADISH" title="$l10n_fillType_oilRadish" showOnPriceTable="false" pricePerLiter="0.250" >
    --     -- 	<image hud="$dataS2/menu/hud/fillTypes/hud_fill_oilRadish.png" hudSmall="$dataS2/menu/hud/fillTypes/hud_fill_oilRadish_sml.png" />
    --     -- 	<physics massPerLiter="0.41" maxPhysicalSurfaceAngle="22.5" />
    --     -- 	<pallet filename="$data/objects/pallets/fillablePallet/fillablePallet.xml" />
    --     -- </fillType>

    --     -- <densityMapHeightType fillTypeName="pigFood" maxSurfaceAngle="40" fillToGroundScale="1.0" allowsSmoothing="false" >
    --     -- <collision scale="1.00" baseOffset="0.0" minOffset="0.0" maxOffset="0.0" />
    --     -- <textures diffuse="$data/fillPlanes/pigFood_diffuse.png" normal="$data/fillPlanes/pigFood_normal.png" distance="$data/fillPlanes/distance/pigFoodDistance_diffuse.png" />
    --     -- </densityMapHeightType>


    --     -- <fillType name="PIGFOOD" title="$l10n_fillType_pigFood" showOnPriceTable="false" pricePerLiter="1.4" >
    --     -- <image hud="$dataS2/menu/hud/fillTypes/hud_fill_pigFood.png" hudSmall="$dataS2/menu/hud/fillTypes/hud_fill_pigFood_sml.png" />
    --     -- <physics massPerLiter="0.65" maxPhysicalSurfaceAngle="23" />
    --     -- </fillType>



            
    --         local sugarFilType = g_fillTypeManager:addFillType(fillTypeName:upper(), g_i18n:getText(fillTypeName:lower(), true, price, 0.00045, math.rad(10), normalHudFile, smallHudFile, modDirectory, nil, { 1, 1, 1 }, nil, false)

    -- end

    local function getCalculatedFillTypePrice(referenceFillTypeName, priceFactor, fallbackPrice)
        local referenceFilltype = g_fillTypeManager:getFillTypeByName(referenceFillTypeName:upper())

        if referenceFilltype == nil then
            self:printDebug(string.format( "Filltype '%s' not found, using fallback price", tostring(referenceFillTypeName) ))
            return fallbackPrice
        else
            self:printDebugVar("referenceFilltype.pricePerLiter", referenceFilltype.pricePerLiter)
            return referenceFilltype.pricePerLiter * priceFactor
        end

    end

    local sugarPrice = getCalculatedFillTypePrice("sugarBeet", (5*1.35), 823/1000) -- 5x beet price (due to 20% sugar volume) adjusted with 35% sugar price premium
    -- local pulpBiogasPrice = getCalculatedFillTypePrice("silage", 0.9, 39/1000)
    -- local pulpPrice = pulpBiogasPrice / 4
    local pulpPrice = getCalculatedFillTypePrice("silage", 0.25, 42/1000)
    local molassesPrice = (760/480) * 0.8 -- 80% of reference value from StrawHarvest
    local feedPelletPrice = ((molassesPrice * 0.05) + (pulpPrice * 0.95)) * 3.47 * 2 -- (80/20 pulp+molasses) * (adj for compaction) * (sell price premium)

    -- self:printDebugVar("sugarPrice", sugarPrice)

    addFillTypeToCurrentMission("sugar", sugarPrice, 0.85/1000, 35)
    addHeightTypeToMission("sugar", 35, false, "LIME" )
    addFillTypeToCategories("sugar", {"BULK", "TRAINWAGON", "AUGERWAGON", "LOADINGVEHICLE"})

    addFillTypeToCurrentMission("beetPulp", pulpPrice, 0.30/1000, 45)
    addHeightTypeToMission("beetPulp", 45, true, "CHAFF" )
    addFillTypeToCategories("beetPulp", {"BULK", "TRAINWAGON", "AUGERWAGON", "FORAGEWAGON", "SILAGETRAILER", "FORK", "LOADINGVEHICLE"})

    addFillTypeToCurrentMission("feedPellets", feedPelletPrice, 0.65/1000, 30)
    addHeightTypeToMission("feedPellets", 30, false, "WOODCHIPS" )
    addFillTypeToCategories("feedPellets", {"BULK", "TRAINWAGON", "AUGERWAGON", "FORAGEWAGON", "SILAGETRAILER", "FORK", "LOADINGVEHICLE"})

    addFillTypeToCurrentMission("molasses", molassesPrice, (1.38/1000), 30) -- TODO: weight currently halfed to be handleable in 2000L tanks
    -- addHeightTypeToMission("feedPellets", 30, false, "WOODCHIPS" )
    addFillTypeToCategories("molasses", {"LIQUID"})
    -- loadMaterialHolder("feedPellets")


    self.priceLevels = {
        sugar = sugarPrice,
        pulp = pulpPrice,
        -- pulpBiogas = pulpBiogasPrice,
        molasses = molassesPrice,
        feedPellets = feedPelletPrice,
    }

    g_currentMission.hud.fillLevelsDisplay:refreshFillTypes(g_fillTypeManager)
end

-- function StrawHarvest:delete()
--     self:unloadFillTypes()
--     self:unloadBaleTypes()

--     self.baleCounterHud:delete()
-- end

-- ---Register the pellet filltypes early in order to be able to add them to the food groups for the animals.
-- function StrawHarvest.fillTypeInit(modDirectory, fillTypeManager, i18n)
--     StrawHarvest.loadStrawPelletFillType(modDirectory, fillTypeManager, i18n)
--     StrawHarvest.loadHayPelletFillType(modDirectory, fillTypeManager, i18n)
-- end

-- function StrawHarvest:heightTypeInit(modDirectory, fillTypeManager, densityMapHeightManager)
--     -- Test if we can load 2 more height types (straw and hay pellets).
--     if self.densityMapHeightManager.numHeightTypes + 2 > (2 ^ self.mission.terrainDetailHeightTypeNumChannels) - 1 then
--         self.failedToLoadDueTooManyHeightTypes = true
--     end

--     StrawHarvest.loadStrawPelletHeightType(modDirectory, fillTypeManager, densityMapHeightManager)
--     StrawHarvest.loadHayPelletHeightType(modDirectory, fillTypeManager, densityMapHeightManager)
-- end

-- function StrawHarvest:onMapLoaded(mission, node)
--     self:loadFillTypes()
--     self:loadBaleTypes()
-- end

-- function StrawHarvest:onMissionLoaded(mission)
--     self.baleCounterHud:load()

--     -- If we were unable to load the height types we need to quit or errors will happen during gameplay.
--     if self.failedToLoadDueTooManyHeightTypes then
--         self.gui:showInfoDialog({
--             dialogType = DialogElement.TYPE_INFO,
--             text = self.i18n:getText("strawHarvest_message_failedHeightTypes"),
--             target = nil,
--             callback = function()
--                 OnInGameMenuMenu()
--             end
--         })
--     end
-- end



-- local modDirectory = g_currentModDirectory














-- function onLoadMapFinished(mission, node)
-- 	local pricesugar = g_fillTypeManager:getFillTypeByName("MAIZE").pricePerLiter
	
	
-- 	if node ~= 0 then
	
-- 	local sugarHudFile = "hud/hud_fill_sugar.dds"
-- 	local sugarHudFileSmall = "hud/hud_fill_sugar_sml.dds"

	
--     local sugarFilType = g_fillTypeManager:addFillType("SUGAR", g_i18n:getText("sugar"), true, pricesugar * 2.0, 0.00045, math.rad(10), sugarHudFile, sugarHudFileSmall,modDirectory, nil, { 1, 1, 1 }, nil, false)
	
-- 	g_currentMission.hud.fillLevelsDisplay:refreshFillTypes(g_fillTypeManager)
-- 	end;
-- end;

-- function load(id, xmlFile, key,customEnvironment)
-- 	local hasmaize =false
-- 	local hassugar=false	
	
	
-- 	local object=id
-- 	if object == nil then
-- 	else
-- 	hasmaize =false
-- 	hassugar=false
	
	
-- 	for i,filltype in pairs(object.acceptedFillTypes) do
-- 	local fillname=g_fillTypeManager.indexToName[i]
-- 		if fillname == "MAIZE" then
-- 		hasmaize=true
-- 	end;
-- 		if fillname == "SUGAR" then
-- 		hassugar=true
-- 	end;
		
-- end;

-- 		if hasmaize and not hassugar then
-- 		local filltypen = g_fillTypeManager:getFillTypeIndexByName("SUGAR")
-- 		local price = g_fillTypeManager:getFillTypeByName("SUGAR").pricePerLiter
-- 			object:addAcceptedFillType(filltypen,price,true,false)
-- 			object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("SUGAR")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("MAIZE")]
-- 			object:initPricingDynamics()
-- 		end;
		
-- 	end;
-- end;


-- FSBaseMission.loadMapFinished = Utils.prependedFunction(FSBaseMission.loadMapFinished, function(self, ...) 
--     if BeetHarvestAddon.loadMapFinished ~= nil and type(BeetHarvestAddon.loadMapFinished) == "function" then
--         BeetHarvestAddon:loadMapFinished(...)
--     end
-- end)

-- FSBaseMission.loadMapFinished = Utils.prependedFunction(FSBaseMission.loadMapFinished, onLoadMapFinished)
-- SellingStation.load = Utils.appendedFunction(SellingStation.load, load)






-- SellingStation.load = Utils.overwrittenFunction(SellingStation.load, StrawHarvest.inj_sellingStation_load)
-- function StrawHarvest.inj_sellingStation_load(object, superFunc, ...)
--     if not superFunc(object, ...) then
--         return false
--     end

SellingStation.load = Utils.appendedFunction(SellingStation.load, function(sellStation, xmlFile, key,customEnvironment)
    if sellStation == nil then -- Should never happen, but let's do the check just in case anyway
        return
    end

    if BeetHarvestAddon.settings.autoAddToSellpoints then

        -- BeetHarvestAddon:printDebugVar("SellingStation.key", xmlFile)

        -- local hasEggs, hasSugar, hasPigFood, hasTMR = false, false, false, false

        -- DebugUtil.printTableRecursively(FillType, "FillType:: ", 0, 2)

        -- --TODO: more efficient way to check!
        -- for fillTypeIndex,_ in pairs(sellStation.acceptedFillTypes) do
        --     local fillTypeName=g_fillTypeManager.indexToName[fillTypeIndex]

        --     -- local acceptsStraw = object.acceptedFillTypes[FillType.STRAW]
        --     -- local acceptsHay = object.acceptedFillTypes[FillType.DRYGRASS_WINDROW]
        

        --     hasEggs = hasEggs or fillTypeName:upper() == "EGG"
        --     hasSugar = hasSugar or fillTypeName:upper() == "SUGAR"
        -- end

        local hasEggs = sellStation.acceptedFillTypes[FillType.EGG]
        local hasSugar = sellStation.acceptedFillTypes[FillType.SUGAR]
        local hasHay = sellStation.acceptedFillTypes[FillType.DRYGRASS_WINDROW]
        local hasFeedPellets = sellStation.acceptedFillTypes[FillType.FEEDPELLETS]

        local needsUpdate = false

        if hasEggs and not hasSugar then
            local fillTypeIndexToAdd = g_fillTypeManager:getFillTypeIndexByName("SUGAR")
            local price = g_fillTypeManager:getFillTypeByName("SUGAR").pricePerLiter
            sellStation:addAcceptedFillType(fillTypeIndexToAdd, price, true, false)
            local priceMultiplier = sellStation.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("EGG")] * 0.99585
            sellStation.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("SUGAR")] = MathUtil.clamp(priceMultiplier, 0.1, 1.0)
            -- BeetHarvestAddon:printDebugVar("sellStation.priceMultipliers", sellStation.priceMultipliers[g_fillTypeManager:getFillTypeIndexByName("SUGAR")])
            needsUpdate = true
            -- sellStation:initPricingDynamics()
        end


        BeetHarvestAddon:printDebugVar("hasHay", hasHay)
        BeetHarvestAddon:printDebugVar("hasFeedPellets", hasFeedPellets)

        local function addRelatedFilltypeToSellstation(fillTypeToAdd, relatedFillType)
            local hasRelatedFilltype = sellStation.acceptedFillTypes[relatedFillType]
            local hasNewFilltype = sellStation.acceptedFillTypes[fillTypeToAdd]

            if hasRelatedFilltype and not hasNewFilltype then

                local price = g_fillTypeManager:getFillTypeByIndex(fillTypeToAdd).pricePerLiter
                local priceMultiplier = sellStation.priceMultipliers[ relatedFillType ] * 0.99765
                sellStation:addAcceptedFillType(fillTypeToAdd, price, true, false)
                sellStation.priceMultipliers[ fillTypeToAdd ] = MathUtil.clamp(priceMultiplier, 0.1, 1.0)
                needsUpdate = true
            end
        end


        addRelatedFilltypeToSellstation(FillType.FEEDPELLETS, FillType.DRYGRASS_WINDROW)
        addRelatedFilltypeToSellstation(FillType.MOLASSES, FillType.SUGARBEET)

        -- if hasHay and not hasFeedPellets then
        --     local fillTypeIndexToAdd = FillType.FEEDPELLETS
        --     local price = g_fillTypeManager:getFillTypeByIndex(fillTypeIndexToAdd).pricePerLiter
        --     local priceMultiplier = sellStation.priceMultipliers[ FillType.DRYGRASS_WINDROW ] * 0.99765
        --     sellStation:addAcceptedFillType(fillTypeIndexToAdd, price, true, false)
        --     -- BeetHarvestAddon:printDebugVar("priceMultiplier:unclamped", priceMultiplier)
        --     -- BeetHarvestAddon:printDebugVar("priceMultiplier:clamped", MathUtil.clamp(priceMultiplier, 0.1, 1.0))
        --     sellStation.priceMultipliers[ fillTypeIndexToAdd ] = MathUtil.clamp(priceMultiplier, 0.1, 1.0)
        --     needsUpdate = true
            
        -- end

        if needsUpdate then 
            sellStation:initPricingDynamics()
        end
    end

    return true
end)

-- Append to BGA
Bga.load = Utils.overwrittenFunction(Bga.load, function (self, superFunc, xmlFile, key, customEnvironment)
    local returnValue = superFunc(self, xmlFile, key, customEnvironment)

    

	if not BeetHarvestAddon.settings.excludePulpFromBGA then
        BeetHarvestAddon:printDebug("Adding to bga")

		if self ~= nil then -- Can this even be possible?

			local silageFilltypeIndex = g_fillTypeManager:getFillTypeIndexByName("SILAGE")
			local beetPulpFilltypeIndex = g_fillTypeManager:getFillTypeIndexByName("BEETPULP")
		
			-- go through all BGA slots and check their fillTypes for "silage"
			for _, slot in pairs(self.bunker.slots) do

				if slot.fillTypes[silageFilltypeIndex] then
					local fillType = {}
					fillType.fillLevel = 0
					fillType.scale = slot.fillTypes[silageFilltypeIndex].scale * 0.8
					fillType.pricePerLiter = slot.fillTypes[silageFilltypeIndex].pricePerLiter * 0.8

					-- add new fillType to fillTypes
					slot.fillTypes[beetPulpFilltypeIndex] = fillType

					-- add slot to fillType-to-slot table
					if self.bunker.fillTypeToSlot[beetPulpFilltypeIndex] == nil then
						self.bunker.fillTypeToSlot[beetPulpFilltypeIndex] = slot
					end
				end
			end

		end
	end
	
    return returnValue
end)





-- ---Add straw and hay pellets to the food groups.
-- function StrawHarvest.inj_animalFoodManager_loadFoodGroups(foodManager, superFunc, xmlFile)
--     if not superFunc(foodManager, xmlFile) then
--         return false
--     end

--     for _, group in pairs(foodManager.foodGroups) do
--         local list = group.content
--         if list ~= nil then
--             for _, foodGroup in ipairs(list) do
--                 if StrawHarvest.hasFillTypeInGroup(foodGroup.fillTypes, FillType.DRYGRASS_WINDROW) then
--                     table.insert(foodGroup.fillTypes, FillType.HAYPELLETS)
--                 end

--                 if StrawHarvest.hasFillTypeInGroup(foodGroup.fillTypes, FillType.STRAW) then
--                     table.insert(foodGroup.fillTypes, FillType.STRAWPELLETS)
--                 end
--             end
--         end
--     end

--     return true
-- end

-- function StrawHarvest.inj_mixerWagon_onLoad(vehicle, savegame)
--     local spec = vehicle.spec_mixerWagon

--     -- Add hay and straw pellets to the supportedFillTypes.
--     for _, fillUnit in pairs(vehicle:getFillUnits()) do
--         if fillUnit.supportedFillTypes[FillType.DRYGRASS_WINDROW] then
--             fillUnit.supportedFillTypes[FillType.HAYPELLETS] = true
--         end

--         if fillUnit.supportedFillTypes[FillType.STRAW] then
--             fillUnit.supportedFillTypes[FillType.STRAWPELLETS] = true
--         end
--     end

--     -- Add hay and straw pellets to the mix entries that have straw and dry grass.
--     for _, mixerWagonFillType in ipairs(spec.mixerWagonFillTypes) do
--         if mixerWagonFillType.fillTypes[FillType.DRYGRASS_WINDROW] ~= nil then
--             mixerWagonFillType.fillTypes[FillType.HAYPELLETS] = true
--             spec.fillTypeToMixerWagonFillType[FillType.HAYPELLETS] = mixerWagonFillType
--         end

--         if mixerWagonFillType.fillTypes[FillType.STRAW] ~= nil then
--             mixerWagonFillType.fillTypes[FillType.STRAWPELLETS] = true
--             spec.fillTypeToMixerWagonFillType[FillType.STRAWPELLETS] = mixerWagonFillType
--         end
--     end
-- end

-- ---Compensate pellets on the mixer wagons.
-- function StrawHarvest.inj_mixerWagon_addFillUnitFillLevel(vehicle, injSuperFunc, superFunc, farmId, fillUnitIndex, fillLevelDelta, fillTypeIndex, toolType, fillPositionData)
--     local delta = injSuperFunc(vehicle, superFunc, farmId, fillUnitIndex, fillLevelDelta, fillTypeIndex, toolType, fillPositionData)
--     if fillTypeIndex == FillType.STRAWPELLETS or fillTypeIndex == FillType.HAYPELLETS then
--         delta = delta * 0.25 -- compensate with the pelletizer.
--     end
--     return delta
-- end

-- ---Add straw to bedding.
-- function StrawHarvest.inj_husbandryModuleStraw_load(module, superFunc, xmlFile, configKey, rootNode, owner)
--     if not superFunc(module, xmlFile, configKey, rootNode, owner) then
--         return false
--     end

--     if module.unloadPlace ~= nil then
--         --Avoid loadPlaces that are not loaded correctly.
--         if module.unloadPlace.fillTypes ~= nil then
--             module.unloadPlace.fillTypes[FillType.STRAWPELLETS] = true
--             module.fillLevels[FillType.STRAWPELLETS] = 0.0
--             module.providedFillTypes[FillType.STRAWPELLETS] = true
--         end
--     end

--     return true
-- end

-- ---Filltype info fix for the straw module.
-- function StrawHarvest.inj_husbandryModuleStraw_getFilltypeInfos(module, superFunc)
--     local result = {}
--     for fillTypeIndex, fillLevel in pairs(module.fillLevels) do
--         local fillType = g_fillTypeManager:getFillTypeByIndex(fillTypeIndex)
--         local freeCapacity = module:getFreeCapacity(fillTypeIndex)
--         table.insert(result, { fillType = fillType, fillLevel = fillLevel, capacity = freeCapacity })
--     end

--     return result
-- end

-- ---Compensate strawpellet/haypellet pallets on the animal husbandry modules.
-- function StrawHarvest.inj_husbandryModuleBase_addFillLevelFromTool(module, superFunc, farmId, deltaFillLevel, fillTypeIndex)
--     local delta = superFunc(module, farmId, deltaFillLevel, fillTypeIndex)
--     if fillTypeIndex == FillType.STRAWPELLETS or fillTypeIndex == FillType.HAYPELLETS then
--         delta = delta * 0.25 -- compensate with the pelletizer.
--     end
--     return delta
-- end

-- ---Add support for selling pellets to selling stations that support hay or straw.
-- function StrawHarvest.inj_sellingStation_load(object, superFunc, ...)
--     if not superFunc(object, ...) then
--         return false
--     end

--     local pelletPriceScale = 0.25
--     local acceptsStraw = object.acceptedFillTypes[FillType.STRAW]
--     local acceptsHay = object.acceptedFillTypes[FillType.DRYGRASS_WINDROW]
--     if acceptsStraw then
--         object:addAcceptedFillType(FillType.STRAWPELLETS, pelletPriceScale, true, false)
--     end

--     if acceptsHay then
--         object:addAcceptedFillType(FillType.HAYPELLETS, pelletPriceScale, true, false)
--     end

--     --Re-init the pricing dynamics for the added pellets.
--     if acceptsStraw or acceptsHay then
--         object:initPricingDynamics()
--     end

--     return true
-- end








-- MixerWagon.onLoad = Utils.appendedFunction(MixerWagon.onLoad, StrawHarvest.inj_mixerWagon_onLoad)
-- MixerWagon.addFillUnitFillLevel = Utils.overwrittenFunction(MixerWagon.addFillUnitFillLevel, StrawHarvest.inj_mixerWagon_addFillUnitFillLevel)

-- HusbandryModuleStraw.load = Utils.overwrittenFunction(HusbandryModuleStraw.load, StrawHarvest.inj_husbandryModuleStraw_load)
-- HusbandryModuleStraw.getFilltypeInfos = Utils.overwrittenFunction(HusbandryModuleStraw.getFilltypeInfos, StrawHarvest.inj_husbandryModuleStraw_getFilltypeInfos)


    -- Fix for both specific as the HusbandryModuleFood isn't calling the superclass..
    -- HusbandryModuleStraw.addFillLevelFromTool = Utils.overwrittenFunction(HusbandryModuleStraw.addFillLevelFromTool, StrawHarvest.inj_husbandryModuleBase_addFillLevelFromTool)
    -- HusbandryModuleFood.addFillLevelFromTool = Utils.overwrittenFunction(HusbandryModuleFood.addFillLevelFromTool, StrawHarvest.inj_husbandryModuleBase_addFillLevelFromTool)



-- ### EXTEND OTHER OBJECTS/VEHICLES ###


--- 
AnimalFoodManager.loadFoodGroups = Utils.overwrittenFunction(AnimalFoodManager.loadFoodGroups, function(foodManager, superFunc, xmlFile)
    if not superFunc(foodManager, xmlFile) then
        return false
    end

    -- Just for logging/information purposes
    if not BeetHarvestAddon:getIsMaizePlusForageActive() then
        BeetHarvestAddon:printDebug("Using feed settings for vanilla/Seasons/Maize+")
    else  -- Special case only for Maize+ with Forage extension
        BeetHarvestAddon:printInfo("Maize+ Forage extension is active, using special Maize+ Forage Extension settings for feed filltype mappings")
    end


    -- table.insert( g_animalFoodManager.foodGroups.COW.content[1].fillTypes, FillType.FEEDPELLETS )

    -- DebugUtil.printTableRecursively(foodManager, "foodManager:: ", 0, 3)

    for animalType, group in pairs(foodManager.foodGroups) do
        -- BeetHarvestAddon:printDebugVar("foodGroup", key)
        local list = group.content
        if list ~= nil then

            local pelletsFoodGroupIndex
            local pulpFoodGroupIndex
            local molassesFoodGroupIndex


            -- BeetHarvestAddon:printDebugVar("List.count", #list)

            -- Default fill type mapping for animals in vanilla game, with Seasons and with Maize+ (w/o Forage extension)
            if not BeetHarvestAddon:getIsMaizePlusForageActive() then
                if animalType == "COW" then
                    pelletsFoodGroupIndex = 1
                    pulpFoodGroupIndex = 2
                elseif animalType == "PIG" then
                    pelletsFoodGroupIndex = 1
                    pulpFoodGroupIndex = 2
                elseif animalType == "SHEEP" then
                    pelletsFoodGroupIndex = 1
                    pulpFoodGroupIndex = 1
                elseif animalType == "HORSE" then
                    pelletsFoodGroupIndex = 2
                    pulpFoodGroupIndex = 1
                end
    

            else  -- Special case only for Maize+ with Forage extension

                if animalType == "COW" then
                    pelletsFoodGroupIndex = (#list > 3 and 4) or 1 -- Make sure we actually have a fourth food group to prevent errors
                    pulpFoodGroupIndex = 2
                    molassesFoodGroupIndex = 3
                elseif animalType == "PIG" then
                    pelletsFoodGroupIndex = 2
                    pulpFoodGroupIndex = (#list > 3 and 4) or 3 -- Make sure we actually have a fourth food group to prevent errors
                    molassesFoodGroupIndex = 1
                elseif animalType == "SHEEP" then
                    pelletsFoodGroupIndex = (#list > 2 and 3) or 1 -- Make sure we actually have a fourth food group to prevent errors
                    pulpFoodGroupIndex = (#list > 1 and 2) or 1 -- Make sure we actually have a fourth food group to prevent errors
                    molassesFoodGroupIndex = (#list > 3 and 4) or 1 -- Make sure we actually have a fourth food group to prevent errors
                elseif animalType == "HORSE" then
                    pelletsFoodGroupIndex = (#list > 2 and 3) or 2 -- Make sure we actually have a fourth food group to prevent errors
                    pulpFoodGroupIndex = (#list > 1 and 2) or 1 -- Make sure we actually have a fourth food group to prevent errors
                    molassesFoodGroupIndex = (#list > 1 and 2) or 1 -- Make sure we actually have a fourth food group to prevent errors
                end

            end

            BeetHarvestAddon:printDebugVar("animalType", animalType)
            BeetHarvestAddon:printDebugVar("pelletsFoodGroupIndex", pelletsFoodGroupIndex)
            BeetHarvestAddon:printDebugVar("pulpFoodGroupIndex", pulpFoodGroupIndex)
            BeetHarvestAddon:printDebugVar("molassesFoodGroupIndex", molassesFoodGroupIndex)


            --- Adds a filltype to a specific food group for the current animal type
            local function addFilltypeToFoodgroup(foodGroupIndex, fillType)
                if foodGroupIndex == nil then return end -- Escape if we have no list index value

                local foodGroup = list[foodGroupIndex]

                if foodGroup ~= nil then
                    table.insert( foodGroup.fillTypes, fillType )
                end
            end

            -- If we have a pellet food group index and that list item is found (not nil), try to add the filltype
            addFilltypeToFoodgroup(pelletsFoodGroupIndex, FillType.FEEDPELLETS)
            addFilltypeToFoodgroup(pulpFoodGroupIndex, FillType.BEETPULP)
            addFilltypeToFoodgroup(molassesFoodGroupIndex, FillType.MOLASSES)


            -- local pelletsFoodGroup = pelletsFoodGroupIndex ~= nil and list[pelletsFoodGroupIndex]
            -- if pelletsFoodGroup ~= nil then
            --     table.insert( pelletsFoodGroup.fillTypes, FillType.FEEDPELLETS )
            -- end

            -- if animalType == "COW" then
            --     table.insert( list[1].fillTypes, FillType.FEEDPELLETS )
            --     DebugUtil.printTableRecursively(list, "foodForCows:: ", 0, 3)
                
            -- end

            -- if animalType == "PIG" then
            --     table.insert( list[1].fillTypes, FillType.FEEDPELLETS )
                
            -- end

            -- for _, foodGroup in ipairs(list) do
            --     if StrawHarvest.hasFillTypeInGroup(foodGroup.fillTypes, FillType.DRYGRASS_WINDROW) then
            --         table.insert(foodGroup.fillTypes, FillType.HAYPELLETS)
            --     end

            --     if StrawHarvest.hasFillTypeInGroup(foodGroup.fillTypes, FillType.STRAW) then
            --         table.insert(foodGroup.fillTypes, FillType.STRAWPELLETS)
            --     end
            -- end
        end
    end

    -- DebugUtil.printTableRecursively(g_animalFoodManager.foodGroups, "g_animalFoodManager.foodGroups2:: ")
    -- DebugUtil.printTableRecursively(g_animalFoodManager.foodMixtures, "g_animalFoodManager.foodMixtures2:: ")
    -- DebugUtil.printTableRecursively(foodManager.foodMixtures, "foodManager.foodMixtures3:: ")


    -- DebugUtil.printTableRecursively(foodManager, "foodManager2:: ", 0, 5)

    return true
end)


-- AnimalFoodManager.loadFoodGroups = Utils.appendedFunction(AnimalFoodManager.loadFoodGroups, function(...)
--     BeetHarvestAddon:printDebug("AnimalFoodManager.loadFoodGroups append")
    
--     return true
-- end)






--- Add straw and hay pellets to the food groups.
AnimalFoodManager.loadMixtures = Utils.overwrittenFunction(AnimalFoodManager.loadMixtures, function(foodManager, superFunc, xmlFile)
    -- if not superFunc(foodManager, xmlFile) then
    --     return false
    -- end

    -- local x = {...}

    BeetHarvestAddon:printDebugVar("xmlFile", xmlFile)
    -- DebugUtil.printTableRecursively(x, "AnimalFoodManager.loadMixtures")

    -- foodManager.foodMixtures[FillType.FEEDPELLETS] = foodManager.foodMixtures[FillType.FEEDPELLETS] or {

    -- return true
    local retVal = superFunc(foodManager, xmlFile)

    
    BeetHarvestAddon:prepareFoodMixtures(foodManager)


    -- foodManager.animalFoodMixtures["PIG"]
    
    -- DebugUtil.printTableRecursively(foodManager.foodGroups.PIG, "foodManager.foodGroups.COW:: ", 0, 3)
    -- DebugUtil.printTableRecursively(foodManager.foodMixtures[49], "foodManager.foodMixtures[49]:: ", 0, 3)

    -- DebugUtil.printTableRecursively(foodManager, "foodManager:: ", 0, 5)


    -- foodManager.animalFoodMixtures["COW"] = foodManager.animalFoodMixtures["COW"] or { FillType.FEEDPELLETS }

    -- foodManager:initDataStructures()




    -- DebugUtil.printTableRecursively(foodManager, "foodManager3:: ", 0, 5)

    return retVal
end)

MixerWagon.onLoad = Utils.appendedFunction(MixerWagon.onLoad, function (vehicle, savegame)
    local spec = vehicle.spec_mixerWagon

    -- Add hay and straw pellets to the supportedFillTypes.
    for _, fillUnit in pairs(vehicle:getFillUnits()) do
        if fillUnit.supportedFillTypes[FillType.FORAGE] then
            fillUnit.supportedFillTypes[FillType.FEEDPELLETS] = true
        end

        -- if fillUnit.supportedFillTypes[FillType.STRAW] then
        --     fillUnit.supportedFillTypes[FillType.STRAWPELLETS] = true
        -- end
    end

    -- Add hay and straw pellets to the mix entries that have straw and dry grass.
    for _, mixerWagonFillType in ipairs(spec.mixerWagonFillTypes) do
        if mixerWagonFillType.fillTypes[FillType.DRYGRASS_WINDROW] ~= nil then
            mixerWagonFillType.fillTypes[FillType.BEETPULP] = true
            -- spec.fillTypeToMixerWagonFillType[FillType.BEETPULP] = FillType.BEETPULP
        end

        -- if mixerWagonFillType.fillTypes[FillType.SILAGE] ~= nil then
        --     mixerWagonFillType.fillTypes[FillType.STRAWPELLETS] = true
        --     spec.fillTypeToMixerWagonFillType[FillType.STRAWPELLETS] = mixerWagonFillType
        -- end
    end
end)

--- Compensate for the material compaction in feed pellets
MixerWagon.addFillUnitFillLevel = Utils.overwrittenFunction(MixerWagon.addFillUnitFillLevel, function(vehicle, injSuperFunc, superFunc, farmId, fillUnitIndex, fillLevelDelta, fillTypeIndex, toolType, fillPositionData)
    if fillTypeIndex == FillType.FEEDPELLETS then
        fillTypeIndex = FillType.BEETPULP
    end


    local x = {
        vehicle, injSuperFunc, superFunc, farmId, fillUnitIndex, fillLevelDelta, fillTypeIndex, toolType, fillPositionData
    }

    -- spec_mixerWagon
    --fillUnitIndex
    --mixerWagonFillTypes
    --fillTypeToMixerWagonFillType
    --

    -- DebugUtil.printTableRecursively(x, "x:: ", 0, 2)

    local delta = injSuperFunc(vehicle, superFunc, farmId, fillUnitIndex, fillLevelDelta, fillTypeIndex, toolType, fillPositionData)
    -- if fillTypeIndex == FillType.STRAWPELLETS or fillTypeIndex == FillType.HAYPELLETS then
    --     delta = delta * 0.25 -- compensate with the pelletizer.
    -- end
    return delta
end)

-- ---Add straw to bedding.
-- function StrawHarvest.inj_husbandryModuleStraw_load(module, superFunc, xmlFile, configKey, rootNode, owner)
--     if not superFunc(module, xmlFile, configKey, rootNode, owner) then
--         return false
--     end

--     if module.unloadPlace ~= nil then
--         --Avoid loadPlaces that are not loaded correctly.
--         if module.unloadPlace.fillTypes ~= nil then
--             module.unloadPlace.fillTypes[FillType.STRAWPELLETS] = true
--             module.fillLevels[FillType.STRAWPELLETS] = 0.0
--             module.providedFillTypes[FillType.STRAWPELLETS] = true
--         end
--     end

--     return true
-- end

-- ---Filltype info fix for the straw module.
-- function StrawHarvest.inj_husbandryModuleStraw_getFilltypeInfos(module, superFunc)
--     local result = {}
--     for fillTypeIndex, fillLevel in pairs(module.fillLevels) do
--         local fillType = g_fillTypeManager:getFillTypeByIndex(fillTypeIndex)
--         local freeCapacity = module:getFreeCapacity(fillTypeIndex)
--         table.insert(result, { fillType = fillType, fillLevel = fillLevel, capacity = freeCapacity })
--     end

--     return result
-- end

---Compensate strawpellet/haypellet pallets on the animal husbandry modules.
HusbandryModuleFood.addFillLevelFromTool = Utils.overwrittenFunction(HusbandryModuleFood.addFillLevelFromTool, function(module, superFunc, farmId, deltaFillLevel, fillTypeIndex)
    local delta = superFunc(module, farmId, deltaFillLevel, fillTypeIndex)
    -- if fillTypeIndex == FillType.STRAWPELLETS or fillTypeIndex == FillType.HAYPELLETS then
    --     delta = delta * 0.25 -- compensate with the pelletizer.
    -- end
    return delta
end)

-- ---Add support for selling pellets to selling stations that support hay or straw.
-- function StrawHarvest.inj_sellingStation_load(object, superFunc, ...)
--     if not superFunc(object, ...) then
--         return false
--     end

--     local pelletPriceScale = 0.25
--     local acceptsStraw = object.acceptedFillTypes[FillType.STRAW]
--     local acceptsHay = object.acceptedFillTypes[FillType.DRYGRASS_WINDROW]
--     if acceptsStraw then
--         object:addAcceptedFillType(FillType.STRAWPELLETS, pelletPriceScale, true, false)
--     end

--     if acceptsHay then
--         object:addAcceptedFillType(FillType.HAYPELLETS, pelletPriceScale, true, false)
--     end

--     --Re-init the pricing dynamics for the added pellets.
--     if acceptsStraw or acceptsHay then
--         object:initPricingDynamics()
--     end

--     return true
-- end










-- Files referenced by script, explicitly stated here to avoid false positives with the TestRunner
function TestRunnerDummy()
    -- hud/hud_fill_sugar.dds
    -- hud/hud_fill_sugar_sml.dds
    -- hud/hud_fill_beetPulp.dds
    -- hud/hud_fill_beetPulp_sml.dds
    -- hud/hud_fill_feedPellets.dds
    -- hud/hud_fill_feedPellets_sml.dds
    -- hud/hud_fill_molasses.dds
    -- hud/hud_fill_molasses_sml.dds
    
    -- hud/monochrome/hud_fill_sugar.dds
    -- hud/monochrome/hud_fill_sugar_sml.dds
    -- hud/monochrome/hud_fill_beetPulp.dds
    -- hud/monochrome/hud_fill_beetPulp_sml.dds
    -- hud/monochrome/hud_fill_feedPellets.dds
    -- hud/monochrome/hud_fill_feedPellets_sml.dds
    -- hud/monochrome/hud_fill_molasses.dds
    -- hud/monochrome/hud_fill_molasses_sml.dds
end